using System;

namespace NDS
{
    /// <summary>
    /// NDS̃Z[ut@C߂̃NXB
    /// </summary>
    public class NDSSave
    {
        //gq̐ݒLqt@C
        private static string SET_EXT = "ext.xml";
        //Z[ut@C̃pX
        private string path;
        //Z[ut@C̃f[^
        private byte[] data;
        //f[^݂̌̈ʒu
        private int position = 0;
        //f[^̃wb_[̒
        private int header = 0;
        //f[^̃tb^[̒
        private int footer = 0;


        /// <summary>
        /// w肵t@C NDSSave CX^X쐬܂B
        /// </summary>
        /// <param name="path">Z[ut@C̃pX</param>
        public NDSSave(string path)
        {
            if (System.IO.File.Exists(path) == true)
            {
                this.path = path;
                this.Load();
                this.CheckExtension();
            }
            else
            {
                throw new System.IO.FileNotFoundException();
            }
        }


        /// <summary>
        /// Z[ut@C̊gq𔻕ʂ܂B
        /// </summary>
        private void CheckExtension()
        {
            //t@CgqƂ̐ݒǂݍ
            System.Xml.XmlDocument document = new System.Xml.XmlDocument();
            document.Load(Program.execpath + SET_EXT);
            System.Xml.XmlNodeList host = document.GetElementsByTagName("extension");
            if (host.Count < 1)
            {
                throw new System.IO.IOException();
            }
            System.Xml.XmlNodeList list = host[0].ChildNodes;
            string[] elist = new string[list.Count];
            string[] dlist = new string[list.Count];
            int[] hlist = new int[list.Count];
            int[] flist = new int[list.Count];
            for (int i = 0; i < list.Count; i++)
            {
                elist[i] = "." + list[i].Name;

                try { dlist[i] = list[i].Attributes["data"].InnerText; }
                catch { dlist[i] = "raw"; }

                try { hlist[i] = int.Parse(list[i].Attributes["head"].InnerText); }
                catch { hlist[i] = 0; }

                try { flist[i] = int.Parse(list[i].Attributes["foot"].InnerText); }
                catch { flist[i] = 0; }
            }
            list = null;
            document = null;

            //wb_[ƃtb^[ݒ肷
            string extension = this.path.Substring(this.path.Length - 4, 4).ToLower();
            for (int i = 0; i < elist.Length; i++)
            {
                if (dlist[i].ToLower().Equals("raw"))
                {
                    if (elist[i].ToLower().Equals(extension.ToLower()))
                    {
                        this.header = hlist[i];
                        this.footer = flist[i];
                        break;
                    }
                }
            }
        }


        /// <summary>
        /// Z[ut@C̃f[^ǂݍ݂܂B
        /// </summary>
        private void Load()
        {
            this.data = System.IO.File.ReadAllBytes(this.path);
        }


        /// <summary>
        /// Z[ut@C̃f[^o܂B
        /// </summary>
        public void Output()
        {
            System.IO.File.WriteAllBytes(this.path, this.data);
        }


        /// <summary>
        /// Z[ut@C̃f[^Vt@Cɏo܂B
        /// </summary>
        /// <param name="path"></param>
        public void Output(string path)
        {
            System.IO.File.WriteAllBytes(path, this.data);
            this.path = path;
        }


        /// <summary>
        /// Z[ut@C̃f[^obNAbv܂B
        /// </summary>
        public void Backup()
        {
            System.IO.File.WriteAllBytes(this.path + "." + System.DateTime.Now.ToString("yyMMddHHmmss"), this.data);
        }


        /// <summary>
        /// ݂̈ʒuړ܂B
        /// </summary>
        /// <param name="position">ړ̃AhX</param>
        public void Seek(int position)
        {
            this.position = this.header + position;
            if (this.position >= this.data.Length - this.footer)
            {
                this.position = this.data.Length - this.footer - 1;
            }
            else if (this.position < this.header)
            {
                this.position = this.header;
            }
        }


        /// <summary>
        /// ݂̈ʒu擾܂B
        /// </summary>
        /// <returns>݂̈ʒu</returns>
        public int GetPosition()
        {
            return this.position;
        }


        /// <summary>
        /// f[^1oCg݂܂B
        /// </summary>
        /// <param name="data">1oCg̃f[^</param>
        public void Write(int data)
        {
            this.data[this.position] = (byte)(0xFF & data);
            this.Seek(this.position + 1);
        }


        /// <summary>
        /// f[^2oCg݂܂B
        /// </summary>
        /// <param name="data">2oCg̃f[^</param>
        public void Write2(int data)
        {
            this.Write(0xFF & data);
            this.Write(0xFF & (data >> 8));
        }


        /// <summary>
        /// f[^4oCg݂܂B
        /// </summary>
        /// <param name="data">4oCg̃f[^</param>
        public void Write4(int data)
        {
            this.Write(0xFF & data);
            this.Write(0xFF & (data >> 8));
            this.Write(0xFF & (data >> 16));
            this.Write(0xFF & (data >> 24));
        }


        /// <summary>
        /// f[^1oCgǂݍ݂܂B
        /// </summary>
        /// <returns>1oCg̃f[^</returns>
        public int Read()
        {
            int result = data[this.position];
            this.Seek(this.position + 1);
            return result;
        }


        /// <summary>
        /// f[^2oCgǂݍ݂܂B
        /// </summary>
        /// <returns>2oCg̃f[^</returns>
        public int Read2()
        {
            return this.Read() + (this.Read() << 8);
        }


        /// <summary>
        /// f[^4oCgǂݍ݂܂B
        /// </summary>
        /// <returns>4oCg̃f[^</returns>
        public int Read4()
        {
            return this.Read() + (this.Read() << 8) + (this.Read() << 16) + (this.Read() << 24);
        }


        /// <summary>
        /// Z[ut@C݉\ʂ݂܂B
        /// </summary>
        /// <returns>ǂݎpt@CȂfalseAȊOȂtrueԂB</returns>
        public bool IsWritable()
        {
            if ((System.IO.File.GetAttributes(this.path) & System.IO.FileAttributes.ReadOnly) == System.IO.FileAttributes.ReadOnly)
            {
                return false;
            }
            else
            {
                return true;
            }
        }


    }
}