﻿using System;
using System.IO;
using NDS;

public class Program
{
    private const string CSUM_FILE = "csum.txt";
    public static string execpath = string.Empty;
    private static int[,] csum;


    public static void Main(string[] args)
    {
        execpath = System.Windows.Forms.Application.StartupPath;
        if (execpath.EndsWith("\\") == false)
        {
            execpath += "\\";
        }

        Load();

        for (int i = 0; i < args.Length; i++)
        {
            Adjust(args[i]);
        }
    }


    private static void Load()
    {
        string[] lines = File.ReadAllLines(execpath + CSUM_FILE);
        csum = new int[lines.Length, 2];
        for (int i = 0; i < lines.Length; i++)
        {
            string[] values = lines[i].Split(new char[] { ',', '\t' });
            csum[i, 0] = Convert.ToInt32(values[0], 16);
            csum[i, 1] = Convert.ToInt32(values[1], 16);
        }
    }


    private static void Adjust(string filepath)
    {
        NDSSave save = new NDSSave(filepath);

        for (int i = 0; i < csum.GetLength(0); i++)
        {
            long tmp = 0;

            save.Seek(csum[i, 0]);
            if (save.Read() == 0x50)
            {
                save.Seek(csum[i, 0] + 0x10);
                while (save.GetPosition() <= csum[i, 1])
                {
                    tmp += save.Read2();
                }

                int sum = (int)tmp;
                int over = (0xFFFF & (sum >> 16));
                over += 0xFFFF & (((0xFFFF & sum) + over) >> 16);
                sum = 0xFFFF - (0xFFFF & (sum + over));
                save.Seek(csum[i, 0] + 0x0E);
                save.Write2(sum);
            }
        }

        save.Output();
    }


}
